## scipy 1.16.3

=== subprojects/highs/CMakeLists.txt ===
# The top-level CMake file is there to bring all modules into scope. That
# means, adding the subdirectories for all CMake projects in this tree, and
# finding external libraries and turning them into imported targets.

# Require CMake 3.15+ (matching scikit-build-core) Use new versions of all
# policies up to CMake 3.27
cmake_minimum_required(VERSION 3.15...3.27)

# set preference for clang compiler and intel compiler over gcc and other compilers
include(Platform/${CMAKE_SYSTEM_NAME}-Determine-C OPTIONAL)
include(Platform/${CMAKE_SYSTEM_NAME}-C OPTIONAL)
set(CMAKE_C_COMPILER_NAMES clang icc cc ${CMAKE_C_COMPILER_NAMES})

include(Platform/${CMAKE_SYSTEM_NAME}-Determine-CXX OPTIONAL)
include(Platform/${CMAKE_SYSTEM_NAME}-CXX OPTIONAL)
set(CMAKE_CXX_COMPILER_NAMES clang++ icpc c++ ${CMAKE_CXX_COMPILER_NAMES})

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

include(set-version)
set_version(VERSION)

project(HIGHS VERSION ${VERSION} LANGUAGES CXX C)

set(PROJECT_NAMESPACE highs)
message(STATUS "${PROJECT_NAME} version: ${PROJECT_VERSION}")

# use C++11 standard
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

# Require out-of-source builds
file(TO_CMAKE_PATH "${PROJECT_BINARY_DIR}/CMakeLists.txt" LOC_PATH)
if(EXISTS "${LOC_PATH}")
  message(FATAL_ERROR "You cannot build in a source directory (or any directory with a CMakeLists.txt file).
    Please make a build subdirectory. Feel free to remove CMakeCache.txt and CMakeFiles.")
endif()
option(FAST_BUILD "Fast build: " ON)

find_program(GIT git)

if((GIT) AND(EXISTS ${HIGHS_SOURCE_DIR}/.git))
    execute_process(
    COMMAND ${GIT} status
    WORKING_DIRECTORY ${HIGHS_SOURCE_DIR} OUTPUT_QUIET)

    execute_process(
    COMMAND ${GIT} describe --always
    WORKING_DIRECTORY ${HIGHS_SOURCE_DIR}
    OUTPUT_VARIABLE GITHASH OUTPUT_STRIP_TRAILING_WHITESPACE)
  # string(REGEX REPLACE "^.*-g" "" GITHASH ${GITHASH})
else()
  set(GITHASH "n/a")
endif()

message(STATUS "Git hash: " ${GITHASH})
# By default only build the C++ library.
option(BUILD_CXX "Build C++ library" ON)
message(STATUS "Build C++ library: ${BUILD_CXX}")

option(BUILD_TESTING "Build Tests" ON)

option(FORTRAN "Build Fortran interface" OFF)
message(STATUS "Build Fortran: ${FORTRAN}")
option(CSHARP "Build CSharp interface" OFF)
message(STATUS "Build CSharp: ${CSHARP}")

if (FORTRAN OR CSHARP)
  set(BUILD_SHARED_LIBS ON)
endif()

option(PYTHON_BUILD_SETUP "Build Python interface from setup.py" OFF)
message(STATUS "Build Python: ${PYTHON_BUILD_SETUP}")
if (PYTHON_BUILD_SETUP)
  set(BUILD_CXX OFF)
  set(BUILD_TESTING OFF)
endif()

include(CMakeDependentOption)

CMAKE_DEPENDENT_OPTION(ALL_TESTS "Build all tests" OFF "BUILD_TESTING;BUILD_CXX" OFF)
message(STATUS "Build all tests: ${ALL_TESTS}")

option(ZLIB "ZLIB" ON)
message(STATUS "ZLIB: ${ZLIB}")
if (PYTHON_BUILD_SETUP)
  set(ZLIB OFF)
endif()

# Address | Thread | Leak 
# Linux atm
# Only Debug is theted atm 
# See below for RelWithDeb info, todo test wip
set(DEBUG_MEMORY "Off" CACHE STRING "Sanitizers")

# emscripten
option(EMSCRIPTEN_HTML "Emscripten HTML output" OFF)

if (BUILD_CXX)
  # Default Build Type to be Release
  get_property(isMultiConfig GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
  if(isMultiConfig)
    if(NOT CMAKE_CONFIGURATION_TYPES)
      set(CMAKE_CONFIGURATION_TYPES "Release;Debug" CACHE STRING
      "Choose the type of builds, options are: Debug Release RelWithDebInfo MinSizeRel. (default: Release;Debug)"
      FORCE)
    endif()
    message(STATUS "Configuration types: ${CMAKE_CONFIGURATION_TYPES}")
  else()
    if (CMAKE_BUILD_TYPE STREQUAL Release)
      set(HiGHSRELEASE ON)
      add_compile_definitions("NDEBUG")# whether to use shared or static libraries
    else()
      if(NOT CMAKE_BUILD_TYPE)
        set(CMAKE_BUILD_TYPE "Release" CACHE STRING
        "Choose the type of build, options are: Debug Release RelWithDebInfo MinSizeRel. (default: Release)"
        FORCE)
        set(HiGHSRELEASE ON)
        add_compile_definitions("NDEBUG")
      endif()
    endif()
    message(STATUS "Build type: ${CMAKE_BUILD_TYPE}")
  endif()

  include(GNUInstallDirs)

  if(UNIX)
    option(BUILD_SHARED_LIBS "Build shared libraries (.so or .dyld)." ON)
    set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR})
    set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR})
    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_BINDIR})
    # for multi-config build system (e.g. xcode)
    foreach(OUTPUTCONFIG IN LISTS CMAKE_CONFIGURATION_TYPES)
      string(TOUPPER ${OUTPUTCONFIG} OUTPUTCONFIG)
      set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${CMAKE_BINARY_DIR}/${OUTPUTCONFIG}/${CMAKE_INSTALL_LIBDIR})
      set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${CMAKE_BINARY_DIR}/${OUTPUTCONFIG}/${CMAKE_INSTALL_LIBDIR})
      set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${CMAKE_BINARY_DIR}/${OUTPUTCONFIG}/${CMAKE_INSTALL_BINDIR})
    endforeach()
  else()
    option(BUILD_SHARED_LIBS "Build shared libraries (.dll)." OFF)
    set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_BINDIR})
    set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_BINDIR})
    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_BINDIR})
    # for multi-config builds (e.g. msvc)
    foreach(OUTPUTCONFIG IN LISTS CMAKE_CONFIGURATION_TYPES)
      string(TOLOWER ${OUTPUTCONFIG} OUTPUTCONFIG)
      set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_BINDIR}/${OUTPUTCONFIG})
      set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_BINDIR}/${OUTPUTCONFIG})
      set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_BINDIR}/${OUTPUTCONFIG})
      # set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${CMAKE_BINARY_DIR}/${OUTPUTCONFIG}/${CMAKE_INSTALL_BINDIR})
      # set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${CMAKE_BINARY_DIR}/${OUTPUTCONFIG}/${CMAKE_INSTALL_BINDIR})
      # set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${CMAKE_BINARY_DIR}/${OUTPUTCONFIG}/${CMAKE_INSTALL_BINDIR})
    endforeach()
  endif()

  if(BUILD_SHARED_LIBS AND MSVC)
    set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
  endif()

  if (BUILD_TESTING)
    include(CTest)
  endif()

  if(MSVC)
    # This option is only available when building with MSVC. By default, highs
    # is build using the cdecl calling convention, which is useful if you're
    # writing C. However, the CLR and Win32 API both expect stdcall.
    #
    # If you are writing a CLR program and want to link to highs, you'll want
    # to turn this on by invoking CMake with the "-DSTDCALL=ON" argument.
    option(STDCALL "Build highs with the __stdcall convention" OFF)
  endif()

  # Basic type
  include(CMakePushCheckState)
  cmake_push_check_state(RESET)
  set(CMAKE_EXTRA_INCLUDE_FILES "cstdint")
  include(CheckTypeSize)
  check_type_size("long" SIZEOF_LONG LANGUAGE CXX)
  message(STATUS "Found long size: ${SIZEOF_LONG}")
  check_type_size("long long" SIZEOF_LONG_LONG LANGUAGE CXX)
  message(STATUS "Found long long size: ${SIZEOF_LONG_LONG}")
  check_type_size("int64_t" SIZEOF_INT64_T LANGUAGE CXX)
  message(STATUS "Found int64_t size: ${SIZEOF_INT64_T}")

  check_type_size("unsigned long" SIZEOF_ULONG LANGUAGE CXX)
  message(STATUS "Found unsigned long size: ${SIZEOF_ULONG}")
  check_type_size("unsigned long long" SIZEOF_ULONG_LONG LANGUAGE CXX)
  message(STATUS "Found unsigned long long size: ${SIZEOF_ULONG_LONG}")
  check_type_size("uint64_t" SIZEOF_UINT64_T LANGUAGE CXX)
  message(STATUS "Found uint64_t size: ${SIZEOF_UINT64_T}")

  check_type_size("int *" SIZEOF_INT_P LANGUAGE CXX)
  message(STATUS "Found int * size: ${SIZEOF_INT_P}")
  cmake_pop_check_state()
 
  # Use current CMAKE_C_FLAGS and CMAKE_CXX_FLAGS when checking for IPO support,
  # instead of defaults: https://cmake.org/cmake/help/latest/policy/CMP0138.html
  if(MSVC AND BUILD_SHARED_LIBS)
    # MSVC does support LTO, but WINDOWS_EXPORT_ALL_SYMBOLS does not work if
    # LTO is enabled.
    set(ipo_supported NO)
    message(STATUS "IPO / LTO not supported on MSVC when building a shared library")
  elseif(MINGW AND NOT CLANG)
    # MinGW supports LTO, but it causes tests to fail at runtime like this:
    #
    #   Mingw-w64 runtime failure:
    #   32 bit pseudo relocation at 00007FF779C9D070 out of range, targeting 00007FFAAC101400, yielding the value 000000033246438C.
    #
    # TODO Figure out and fix the root cause of that, then remove this section.
    set(ipo_supported NO)
    message(STATUS "IPO / LTO not currently supported building HiGHS on MinGW")
  else()
    if(CMAKE_VERSION VERSION_GREATER_EQUAL  "3.24.0") 
      cmake_policy(SET CMP0138 NEW)
    endif()

    include(CheckIPOSupported)
    check_ipo_supported(RESULT ipo_supported OUTPUT check_ipo_support_output)
    message(STATUS "IPO / LTO supported by compiler: ${ipo_supported}")
  endif()

  if(DEFINED CMAKE_INTERPROCEDURAL_OPTIMIZATION)
    # The user explicitly requested IPO. If it's not supported, CMake *should*
    # produce an error: https://cmake.org/cmake/help/latest/policy/CMP0069.html
    # However, we can give a more helpful error message ourselves.
    message(STATUS "IPO / LTO: ${CMAKE_INTERPROCEDURAL_OPTIMIZATION} as requested by user")
    if(CMAKE_INTERPROCEDURAL_OPTIMIZATION AND NOT ipo_supported)
      message(SEND_ERROR
              "IPO / LTO was requested through CMAKE_INTERPROCEDURAL_OPTIMIZATION, "
              "but it is not supported by the compiler. The check failed with this output:\n"
              "${check_ipo_support_output}")
    endif()
  elseif(NOT ipo_supported OR (APPLE AND FORTRAN))
    message(STATUS "IPO / LTO: disabled because it is not supported")
  elseif(NOT BUILD_SHARED_LIBS)
    # For a static library, we can't be sure whether the final linking will
    # happen with IPO enabled, so we err on the side of caution. A better
    # approach would be to request "fat LTO" in this case (for gcc/clang), to
    # make the static library usable whether or not LTO is enabled at link
    # time. Unfortunately CMake makes that impossible:
    # https://gitlab.kitware.com/cmake/cmake/-/issues/23136
    message(STATUS
            "IPO / LTO: disabled by default when building a static library; "
            "set CMAKE_INTERPROCEDURAL_OPTIMIZATION=ON to enable")
  else()
    set(CMAKE_INTERPROCEDURAL_OPTIMIZATION TRUE)
    message(STATUS "IPO / LTO: enabled")
  endif()
endif()

include(CheckCXXSourceCompiles)
check_cxx_source_compiles(
  "#include <immintrin.h>
    int main () {
        _mm_pause();
        return 0;
    }"
  HIGHS_HAVE_MM_PAUSE)

if(MSVC)
  check_cxx_source_compiles(
    "#include <intrin.h>
        #pragma intrinsic(_BitScanReverse)
        #pragma intrinsic(_BitScanReverse64)
        int main () {
            unsigned long x = 5;
            unsigned long y;
            _BitScanReverse(&y, x);
            _BitScanReverse64(&x, y);
            return 0;
        }"
    HIGHS_HAVE_BITSCAN_REVERSE)
else()
  check_cxx_source_compiles(
    "#include <cstdint>
         int main () {
            unsigned int x = 5;
            unsigned long long y = __builtin_clz(x);
            x = __builtin_clzll(y);
            return 0;
        }"
    HIGHS_HAVE_BUILTIN_CLZ)
endif()

set(CMAKE_MACOSX_RPATH ON)

if (BUILD_DOTNET)
    set(CMAKE_BUILD_WITH_INSTALL_RPATH TRUE)
else()
    # use, i.e. don't skip the full RPATH for the build tree
    set(CMAKE_SKIP_BUILD_RPATH FALSE)

    # when building, don't use the install RPATH already
    # (but later on when installing)
    set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
    set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
endif()

if(NOT FAST_BUILD)
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${HIGHS_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR})

=== subprojects/highs/meson_options.txt ===
# Booleans
option('fast_build',
       type : 'boolean',
       value : false)
option('highsint64',
       type : 'boolean',
       value : true)
option('use_zlib',
       type : 'feature')
option('with_fortran',
       type : 'boolean',
       value : false)
option('with_csharp',
       type : 'boolean',
       value : false)
option('debug_sol',
      type: 'boolean',
      value: false)
option('with_stdcall',
      type: 'boolean',
      description: 'Build highs with the __stdcall convention',
      value: false)
option('with_tests',
      type: 'boolean',
      value: false)
option('with_pybind11',
       type : 'boolean',
       value : false)
option('do_install',
       type : 'boolean',
       value : true)

=== scipy/odr/odrpack/Makefile ===
# Make the ODRPACK library

FC = g77
FOPT = -O
LIB = libodrpack.a
OBJS = d_odr.o d_mprec.o d_lpkbls.o dlunoc.o

.f.o:
	$(FC) $(FOPT) -c $<

$(LIB): $(OBJS)
	ar cru $(LIB) $(OBJS)

all: $(LIB)

clean:
	rm -f $(LIB) $(OBJS)

=== subprojects/boost_math/math/CMakeLists.txt ===
# Copyright 2020 Peter Dimov
# Copyright 2021 Matt Borland
# Distributed under the Boost Software License, Version 1.0.
# https://www.boost.org/LICENSE_1_0.txt

cmake_minimum_required(VERSION 3.5...3.16)

project(boost_math VERSION 1.88.0 LANGUAGES CXX)

add_library(boost_math INTERFACE)

add_library(Boost::math ALIAS boost_math)

target_include_directories(boost_math INTERFACE include)
if(NOT CMAKE_VERSION VERSION_LESS "3.19")
  file(GLOB_RECURSE headers include/*.hpp)
  target_sources(boost_math PRIVATE ${headers})
endif()

include(CMakeDependentOption)

cmake_dependent_option(BOOST_MATH_STANDALONE "Use Boost.Math in standalone mode" ON "NOT BOOST_SUPERPROJECT_VERSION" OFF)

message(STATUS "Boost.Math: standalone mode ${BOOST_MATH_STANDALONE}")

if(BOOST_MATH_STANDALONE)

  target_compile_definitions(boost_math INTERFACE BOOST_MATH_STANDALONE=1)

else()

  target_link_libraries(boost_math
    INTERFACE
      Boost::assert
      Boost::concept_check
      Boost::config
      Boost::core
      Boost::integer
      Boost::lexical_cast
      Boost::predef
      Boost::random
      Boost::static_assert
      Boost::throw_exception
  )

endif()

if(BUILD_TESTING AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/test/CMakeLists.txt")

  add_subdirectory(test)

# Only enable tests when we're the root project
elseif(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)

  include(CTest)
  add_subdirectory(test)
  
  include(GNUInstallDirs)
  install(DIRECTORY "include/" DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")

endif()

=== subprojects/highs/app/CMakeLists.txt ===
if(FAST_BUILD)
  if (BUILD_CXX)
    # create highs binary using library without pic
    add_executable(highs-bin)

    # Configure the config windows version file
    if(MSVC)
      string(REPLACE "." ","  PROJECT_RC_VERSION "${PROJECT_VERSION}")
      configure_file(${HIGHS_SOURCE_DIR}/version.rc.in
        "${HIGHS_BINARY_DIR}/version.rc" @ONLY)
      set(win_version_file ${HIGHS_BINARY_DIR}/version.rc)
    else()
      set(win_version_file)
    endif()

    target_sources(highs-bin PRIVATE RunHighs.cpp HighsRuntimeOptions.h ${win_version_file})

    target_include_directories(highs-bin PRIVATE
      $<BUILD_INTERFACE:${HIGHS_SOURCE_DIR}/app>
    )

    if(UNIX)
      target_compile_options(highs-bin PUBLIC "-Wno-unused-variable")
      target_compile_options(highs-bin PUBLIC "-Wno-unused-const-variable")
    endif()

    set_target_properties(highs-bin
      PROPERTIES OUTPUT_NAME highs)

    target_link_libraries(highs-bin highs)

    if(APPLE)
        set_target_properties(highs-bin PROPERTIES INSTALL_RPATH 
        "@loader_path/../${CMAKE_INSTALL_LIBDIR};@loader_path")
    elseif (UNIX)
        set_target_properties(highs-bin PROPERTIES INSTALL_RPATH 
        "$ORIGIN:$ORIGIN/../${CMAKE_INSTALL_LIBDIR}")
    endif()

    # install the binary
    install(TARGETS highs-bin EXPORT highs-targets
      RUNTIME)
  endif()
else()
  # create highs binary using library without pic
  add_executable(highs)

  target_sources(highs PRIVATE RunHighs.cpp)

  if(UNIX)
    target_compile_options(highs PUBLIC "-Wno-unused-variable")
    target_compile_options(highs PUBLIC "-Wno-unused-const-variable")
  endif()

  target_link_libraries(highs libhighs)

  if(EMSCRIPTEN AND EMSCRIPTEN_HTML)
    set(CMAKE_EXECUTABLE_SUFFIX ".html")
    set_target_properties(highs PROPERTIES LINK_DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/highs_webdemo_shell.html)
  endif()

  target_include_directories(highs PRIVATE
    $<BUILD_INTERFACE:${HIGHS_SOURCE_DIR}/app>
  )

  # install the binary
  install(TARGETS highs EXPORT highs-targets
    RUNTIME)
endif()

=== subprojects/highs/src/CMakeLists.txt ===
if (NOT BUILD_CXX)
  return()
endif()
  
# Define library.
include(sources)
set(sources ${highs_sources} ${cupdlp_sources} ${ipx_sources} ${basiclu_sources})
set(headers ${highs_headers} ${cupdlp_headers} ${ipx_headers} ${basiclu_headers})

# Configure the config windows version file
if(MSVC)
  string(REPLACE "." ","  PROJECT_RC_VERSION "${PROJECT_VERSION}")
  configure_file(${HIGHS_SOURCE_DIR}/version.rc.in
    "${HIGHS_BINARY_DIR}/version.rc" @ONLY)
  set(win_version_file ${HIGHS_BINARY_DIR}/version.rc)
else()
  set(win_version_file)
endif()

# Outdated CMake approach: update in progress
if(NOT FAST_BUILD)

  add_library(libhighs ${sources} ${headers} ${win_version_file})
  target_include_directories(libhighs PRIVATE ${include_dirs})

  if(${BUILD_SHARED_LIBS})
    # put version information into shared library file
    set_target_properties(libhighs PROPERTIES
      VERSION
      ${HIGHS_VERSION_MAJOR}.${HIGHS_VERSION_MINOR}.${HIGHS_VERSION_PATCH}
      SOVERSION ${HIGHS_VERSION_MAJOR}.${HIGHS_VERSION_MINOR})
    if(MINGW)
      target_compile_definitions(libhighs PUBLIC LIBHIGHS_STATIC_DEFINE)
    endif()
  else()
    # create static highs library with pic
    set_target_properties(libhighs PROPERTIES
      POSITION_INDEPENDENT_CODE on)
    target_compile_definitions(libhighs PUBLIC LIBHIGHS_STATIC_DEFINE)
  endif()

  # on UNIX system the 'lib' prefix is automatically added
  set_target_properties(libhighs PROPERTIES
    OUTPUT_NAME "highs"
    PDB_NAME "libhighs"
    MACOSX_RPATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")

  if(ZLIB AND ZLIB_FOUND)
    target_link_libraries(libhighs ZLIB::ZLIB)
    set(CONF_DEPENDENCIES "include(CMakeFindDependencyMacro)\nfind_dependency(ZLIB)")
  endif()

  # set the install rpath to the installed destination
  set_target_properties(libhighs PROPERTIES INSTALL_RPATH
    "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")

  # install the header files of highs
  foreach(file ${headers})
    get_filename_component(dir ${file} DIRECTORY)

    if(NOT dir STREQUAL "")
      string(REPLACE ../extern/ "" dir ${dir})
    endif()

    install(FILES ${file} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/highs/${dir})
  endforeach()
  install(FILES ${HIGHS_BINARY_DIR}/HConfig.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/highs)

  if(UNIX)
    # target_compile_options(libhighs PRIVATE "-Wno-defaulted-function-deleted")
    # target_compile_options(libhighs PRIVATE "-Wno-return-type-c-linkage")
    target_compile_options(libhighs PRIVATE "-Wno-return-type" "-Wno-switch")

    target_compile_options(libhighs PRIVATE "-Wno-unused-variable")
    target_compile_options(libhighs PRIVATE "-Wno-unused-const-variable")

    # target_compile_options(libhighs PRIVATE "-Wno-sign-compare")
    # target_compile_options(libhighs PRIVATE "-Wno-logical-op-parentheses")

    # target_compile_options(libipx PRIVATE "-Wno-defaulted-function-deleted")
    # target_compile_options(libipx PRIVATE "-Wno-return-type-c-linkage")
    # target_compile_options(libipx PRIVATE "-Wno-return-type" "-Wno-switch")

    # target_compile_options(libipx PRIVATE "-Wno-sign-compare")
    # target_compile_options(libipx PRIVATE "-Wno-logical-op-parentheses")
  endif()
  
  install(TARGETS libhighs EXPORT highs-targets
    LIBRARY
    ARCHIVE
    RUNTIME
    INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/highs)

  # Add library targets to the build-tree export set
  export(TARGETS libhighs
    FILE "${HIGHS_BINARY_DIR}/highs-targets.cmake")

  # Configure the config file for the build tree:
  # Either list all the src/* directories here, or put explicit paths in all the
  # include statements.
  # M reckons that the latter is more transparent, and I'm inclined to agree.
  set(CONF_INCLUDE_DIRS "${HIGHS_SOURCE_DIR}/src" "${HIGHS_BINARY_DIR}")
  configure_file(${HIGHS_SOURCE_DIR}/highs-config.cmake.in
    "${HIGHS_BINARY_DIR}/highs-config.cmake" @ONLY)

  # Configure the config file for the install
  set(CONF_INCLUDE_DIRS "\${CMAKE_CURRENT_LIST_DIR}/../../../${CMAKE_INSTALL_INCLUDEDIR}/highs")
  configure_file(${HIGHS_SOURCE_DIR}/highs-config.cmake.in
    "${HIGHS_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/highs-config.cmake" @ONLY)

  # Configure the pkg-config file for the install
  configure_file(${HIGHS_SOURCE_DIR}/highs.pc.in
    "${HIGHS_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/highs.pc" @ONLY)

  # Install the targets of the highs export group, the config file so that other
  # cmake-projects can link easily against highs, and the pkg-config flie so that
  # other projects can easily build against highs
  install(EXPORT highs-targets FILE highs-targets.cmake DESTINATION
    ${CMAKE_INSTALL_LIBDIR}/cmake/highs)
  install(FILES "${HIGHS_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/highs-config.cmake"
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/highs)
  install(FILES "${HIGHS_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/highs.pc"
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

else()
  # FAST_BUILD is set to on.
  # At the moment used only for gradually updating the CMake targets build and
  # install / export.
  # Define library in modern CMake using target_*()
  # No interfaces (apart from c); No ipx; New (short) ctest instances.
  add_library(highs)
  add_library(${PROJECT_NAMESPACE}::highs ALIAS highs)

  if(${BUILD_SHARED_LIBS})
    # put version information into shared library file
    set_target_properties(highs PROPERTIES
      VERSION
      ${HIGHS_VERSION_MAJOR}.${HIGHS_VERSION_MINOR}.${HIGHS_VERSION_PATCH}
      SOVERSION ${HIGHS_VERSION_MAJOR}.${HIGHS_VERSION_MINOR})
  endif()

  set_target_properties(highs PROPERTIES POSITION_INDEPENDENT_CODE ON)

  if(APPLE)
      set_target_properties(highs PROPERTIES INSTALL_RPATH "@loader_path")
  elseif (UNIX)
      set_target_properties(highs PROPERTIES INSTALL_RPATH "$ORIGIN")
  endif()

  target_include_directories(highs PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    $<BUILD_INTERFACE:${HIGHS_BINARY_DIR}>
    # $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/highs>
  )

  # target_include_directories(highs PRIVATE
  #   $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/interfaces>
  #   $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/io>
  #   $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/pdlp>
  #   $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/pdlp/cupdlp>
  #   $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/ipm>
  #   $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/ipm/ipx>
  #   $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/ipm/basiclu>
  #   $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/lp_data>
  #   $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/mip>
  #   $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/model>
  #   $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/parallel>
  #   $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/presolve>
  #   $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/qpsolver>
  #   $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/simplex>
  #   $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/util>
  #   $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/test>)

  # target_include_directories(highs PRIVATE
  #   $<BUILD_INTERFACE:${HIGHS_SOURCE_DIR}/extern/>
  #   $<BUILD_INTERFACE:${HIGHS_SOURCE_DIR}/extern/filereader>
  #   $<BUILD_INTERFACE:${HIGHS_SOURCE_DIR}/extern/pdqsort>)

  target_sources(highs PRIVATE ${sources} ${headers} ${win_version_file})
  target_include_directories(highs PRIVATE ${include_dirs})

  if(MSVC)
    list(APPEND highs_compile_opts
      "/bigobj" # Allow big object
      "/DNOMINMAX"
      "/DWIN32_LEAN_AND_MEAN=1"
      "/D_CRT_SECURE_NO_WARNINGS"
      "/D_CRT_SECURE_NO_DEPRECATE"
      "/MP" # Build with multiple processes
      "/Zc:preprocessor" # Enable preprocessor conformance mode
      "/fp:precise"
      )
    if (CMAKE_BUILD_TYPE STREQUAL Release)
      list(APPEND highs_compile_opts
        "/DNDEBUG")
    endif()
    # MSVC warning suppressions
    list(APPEND highs_compile_opts
      "/wd4005" # 'macro-redefinition'
      "/wd4018" # 'expression' : signed/unsigned mismatch
      "/wd4065" # switch statement contains 'default' but no 'case' labels
      "/wd4068" # 'unknown pragma'
      "/wd4101" # 'identifier' : unreferenced local variable
      "/wd4146" # unary minus operator applied to unsigned type, result still unsigned
      "/wd4200" # nonstandard extension used : zero-sized array in struct/union
      "/wd4244" # 'conversion' conversion from 'type1' to 'type2', possible loss of data
      "/wd4251" # 'identifier' : class 'type' needs to have dll-interface to be used by clients of class 'type2'
      "/wd4267" # 'var' : conversion from 'size_t' to 'type', possible loss of data
      "/wd4305" # 'identifier' : truncation from 'type1' to 'type2'
      "/wd4307" # 'operator' : integral constant overflow
      "/wd4309" # 'conversion' : truncation of constant value
      "/wd4334" # 'operator' : result of 32-bit shift implicitly converted to 64 bits (was 64-bit shift intended?)
      "/wd4355" # 'this' : used in base member initializer list
      "/wd4477" # 'fwprintf' : format string '%s' requires an argument of type 'wchar_t *'
      "/wd4506" # no definition for inline function 'function'
      "/wd4715" # function' : not all control paths return a value
      "/wd4800" # 'type' : forcing value to bool 'true' or 'false' (performance warning)
      "/wd4996" # The compiler encountered a deprecated declaration.
      )
    target_compile_options(highs PRIVATE ${highs_compile_opts})
  # else()
  #   list(APPEND highs_compile_opts "-fwrapv")
  endif()


  if(ZLIB AND ZLIB_FOUND)
    target_include_directories(highs PRIVATE
      $<BUILD_INTERFACE:${HIGHS_SOURCE_DIR}/extern/zstr>
    )
    target_link_libraries(highs ZLIB::ZLIB)
    set(CONF_DEPS 
      "include(CMakeFindDependencyMacro)\nfind_dependency(Threads)\nfind_dependency(ZLIB)")
    set(CONF_DEPENDENCIES ${CONF_DEPS})
  else() 
    set(CONF_DEPENDENCIES "include(CMakeFindDependencyMacro)\nfind_dependency(Threads)")
  endif()
    

  # # on UNIX system the 'lib' prefix is automatically added
  # set_target_properties(highs PROPERTIES
  # OUTPUT_NAME "highs"
  # MACOSX_RPATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")

  # if (UNIX)
  # set_target_properties(highs PROPERTIES
  # LIBRARY_OUTPUT_DIRECTORY "${HIGHS_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR}")
  # endif()
  
  # set_target_properties(highs PROPERTIES PUBLIC_HEADER "src/Highs.h;src/lp_data/HighsLp.h;src/lp_data/HighsLpSolverObject.h")

  # install the header files of highs
  foreach(file ${headers})
    get_filename_component(dir ${file} DIRECTORY)

    if(NOT dir STREQUAL "")
      string(REPLACE ../extern/ "" dir ${dir})
    endif()

    install(FILES ${file} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/highs/${dir})
  endforeach()
  install(FILES ${HIGHS_BINARY_DIR}/HConfig.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/highs)

  # target_compile_options(highs PRIVATE "-Wall")
  # target_compile_options(highs PRIVATE "-Wunused")
  
  if (UNIX)
    target_compile_options(highs PRIVATE "-Wno-unused-variable")
    target_compile_options(highs PRIVATE "-Wno-unused-const-variable")
  endif()

  # Configure the config file for the build tree:
  # Either list all the src/* directories here, or put explicit paths in all the
  # include statements.
  # M reckons that the latter is more transparent, and I'm inclined to agree.
  set(CONF_INCLUDE_DIRS "${HIGHS_SOURCE_DIR}/src" "${HIGHS_BINARY_DIR}")
  configure_file(${HIGHS_SOURCE_DIR}/highs-config.cmake.in
    "${HIGHS_BINARY_DIR}/highs-config.cmake" @ONLY)

  # Configure the config file for the install
  set(CONF_INCLUDE_DIRS "\${CMAKE_CURRENT_LIST_DIR}/../../../${CMAKE_INSTALL_INCLUDEDIR}")
  configure_file(${HIGHS_SOURCE_DIR}/highs-config.cmake.in
    "${HIGHS_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/highs-config.cmake" @ONLY)

  # Configure the pkg-config file for the install
  configure_file(${HIGHS_SOURCE_DIR}/highs.pc.in
    "${HIGHS_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/highs.pc" @ONLY)

=== subprojects/xsf/tests/CMakeLists.txt ===
set(XSREF_TABLES_PATH "${CMAKE_SOURCE_DIR}/xsref/tables")
find_package(Catch2 3 REQUIRED)
find_package(Arrow REQUIRED)
find_package(Parquet REQUIRED)

add_library(xsf INTERFACE)
target_include_directories(xsf INTERFACE ${CMAKE_SOURCE_DIR}/include)

set(TEST_BASE_DIR "${CMAKE_SOURCE_DIR}/tests")

include(${CMAKE_SOURCE_DIR}/tests/Coverage.cmake)

file(GLOB TEST_SOURCES "*/test_*.cpp")
foreach(test_file ${TEST_SOURCES})
  # Families of tests go in subfolders of xsf/tests. Test files in different
  # folders can have the same name. Try to generate a unique target name based
  # on the test name and its parent folder(s).
  get_filename_component(test_name ${test_file} NAME_WE)
  get_filename_component(test_dir ${test_file} DIRECTORY)
  file(RELATIVE_PATH test_dir ${TEST_BASE_DIR} ${test_dir})
  string(REPLACE "/" "-" test_dir ${test_dir})
  set(target_name ${test_dir}_${test_name})

  add_executable(${target_name} ${test_file})

  target_link_libraries(${target_name} PRIVATE Catch2::Catch2WithMain Arrow::arrow_shared Parquet::parquet_shared xsf)

  target_compile_definitions(${target_name} PRIVATE XSREF_TABLES_PATH="${XSREF_TABLES_PATH}")
  include(CTest)
  include(Catch)
  catch_discover_tests(${target_name})
endforeach()

=== subprojects/boost_math/math/test/CMakeLists.txt ===
# Copyright 2021 Matt Borland
# Distributed under the Boost Software License, Version 1.0.
# https://www.boost.org/LICENSE_1_0.txt

include(BoostTestJamfile OPTIONAL RESULT_VARIABLE HAVE_BOOST_TEST)

if(HAVE_BOOST_TEST)

    boost_test(SOURCES check_cmake_version.cpp ARGUMENTS ${PROJECT_VERSION} LINK_LIBRARIES Boost::core Boost::config)    

    if (BOOST_MATH_ENABLE_CUDA)

        message(STATUS "Building boost.math with CUDA")

        find_package(CUDA REQUIRED)
        enable_language(CUDA)
        set(CMAKE_CUDA_EXTENSIONS OFF)

        enable_testing()

        boost_test_jamfile(FILE cuda_jamfile LINK_LIBRARIES Boost::math Boost::assert Boost::concept_check Boost::config Boost::core Boost::integer Boost::lexical_cast Boost::multiprecision Boost::predef Boost::random Boost::static_assert Boost::throw_exception Boost::unit_test_framework ${CUDA_LIBRARIES} INCLUDE_DIRECTORIES ${CUDA_INCLUDE_DIRS}  )

    elseif (BOOST_MATH_ENABLE_NVRTC)

        message(STATUS "Building boost.math with NVRTC")

        find_package(CUDA REQUIRED)

        enable_testing()

        set(CUDA_nvrtc_LIBRARY /usr/local/cuda/lib64/libnvrtc.so)
        
        if (BOOST_MATH_NVRTC_CI_RUN)
            boost_test_jamfile(FILE nvrtc_jamfile LINK_LIBRARIES Boost::math Boost::assert Boost::concept_check Boost::config Boost::core Boost::integer Boost::lexical_cast Boost::multiprecision Boost::predef Boost::random Boost::static_assert Boost::throw_exception ${CUDA_nvrtc_LIBRARY} ${CUDA_LIBRARIES} ${CUDA_CUDA_LIBRARY} COMPILE_DEFINITIONS BOOST_MATH_NVRTC_CI_RUN=1 INCLUDE_DIRECTORIES ${CUDA_INCLUDE_DIRS} )
        else ()
            boost_test_jamfile(FILE nvrtc_jamfile LINK_LIBRARIES Boost::math Boost::assert Boost::concept_check Boost::config Boost::core Boost::integer Boost::lexical_cast Boost::multiprecision Boost::predef Boost::random Boost::static_assert Boost::throw_exception ${CUDA_nvrtc_LIBRARY} ${CUDA_LIBRARIES} ${CUDA_CUDA_LIBRARY} INCLUDE_DIRECTORIES ${CUDA_INCLUDE_DIRS} )
        endif()

    elseif (BOOST_MATH_ENABLE_SYCL)

        message(STATUS "Building boost.math with SYCL")

        set(CMAKE_CXX_COMPILER "icpx")
        set(CMAKE_C_COMPILER "icx")

        enable_testing()

        boost_test_jamfile(FILE sycl_jamfile LINK_LIBRARIES Boost::math Boost::assert Boost::concept_check Boost::config Boost::core Boost::integer Boost::lexical_cast Boost::multiprecision Boost::predef Boost::random Boost::static_assert Boost::throw_exception Boost::unit_test_framework sycl COMPILE_OPTIONS -fsycl )
    else()

        add_subdirectory(compile_test)

    endif()

endif()

=== scipy/_lib/pyprima/pyprima/tests/requirements.txt ===
numpy
pycutest
pytest
pytest-cov
pytest-order

=== scipy/sparse/linalg/_propack/PROPACK/Makefile ===
#
#     (C) Rasmus Munk Larsen, Stanford University, 2004
#
include ./make.inc
IPATH = -I.

all: 
	@( cd double; \
	$(MAKE) all; \
	cd .. ; \
	cd single; \
	$(MAKE) all; \
	cd .. ; \
	cd complex16; \
	$(MAKE) all; \
	cd .. ; \
	cd complex8; \
	$(MAKE) all; \
	cd .. )		

test: 
	@( cd double; \
	$(MAKE) test; \
	cd .. ; \
	cd single; \
	$(MAKE) test; \
	cd .. ; \
	cd complex16; \
	$(MAKE) test; \
	cd .. ; \
	cd complex8; \
	$(MAKE) test; \
	cd .. )		

verify: 
	@( cd double; \
	$(MAKE) verify; \
	cd .. ; \
	cd single; \
	$(MAKE) verify; \
	cd .. ; \
	cd complex16; \
	$(MAKE) verify; \
	cd .. ; \
	cd complex8; \
	$(MAKE) verify; \
	cd .. )		


clean:	
	rm -f  *.o *.il
	rm -rf rii_files
	@( cd double; \
	$(MAKE) clean; \
	cd .. ; \
	cd single; \
	$(MAKE) clean; \
	cd .. ; \
	cd complex16; \
	$(MAKE) clean; \
	cd .. ; \
	cd complex8; \
	$(MAKE) clean; \
	cd .. )

cleanall:	
	rm -f  *.o *.il *~
	rm -rf rii_files
	@( cd Make; \
	rm -f *~ ; \
	cd .. ; \
	cd double; \
	$(MAKE) cleanall; \
	cd .. ; \
	cd single; \
	$(MAKE) cleanall; \
	cd .. ; \
	cd complex16; \
	$(MAKE) cleanall; \
	cd .. ; \
	cd complex8; \
	$(MAKE) cleanall; \
	cd .. )

=== scipy/sparse/linalg/_propack/PROPACK/complex16/Makefile ===
#
#     (C) Rasmus Munk Larsen, Stanford University, 2004
#
include ../make.inc
IPATH = -I.

all: lib exampleprogs

### Object files.

DOBJ = zlanbpro.o zreorth.o zgetu0.o zsafescal.o dblasext.o zblasext.o \
      zlansvd.o printstat.o zgemm_ovwr.o dgemm_ovwr.o  \
      zlansvd_irl.o dbsvd.o zritzvec.o z$(MGS).o  second.o 

.f.o:
	$(F77) $(FFLAGS) $(IPATH) -c -o $*.o $*.f
.F.o:
	$(F77) $(FFLAGS) $(IPATH) -c -o $*.o $*.F
.c.o:
	$(CC)  $(CFLAGS) $(IPATH) -c -o $*.o $*.c


lib:  liblapack libzpropack_$(PLAT).a 

libzpropack_$(PLAT).a: $(DOBJ)
	rm -f libzpropack_$(PLAT).a
	$(MAKELIB) libzpropack_$(PLAT).a $(DOBJ) 
	$(RANLIB)  libzpropack_$(PLAT).a

liblapack:
	@( cd Lapack_Util; \
	$(MAKE) lib; \
	cd .. )		

exampleprogs: 
	@( cd Examples; \
	$(MAKE) all; \
	cd .. )

test:
	@( cd Examples; \
	$(MAKE) test; \
	cd .. )


verify: 
	@( cd Examples; \
	$(MAKE) verify; \
	cd .. )

clean:	
	rm -f  *.o *.il lib*_$(PLAT).a
	rm -rf rii_files
	@( cd Examples; \
	$(MAKE) clean; \
	cd ..; \
	cd Lapack_Util; \
	$(MAKE) clean; \
	cd .. )

cleanall:	
	rm -f  *.o  *.a *~ *.il
	rm -rf rii_files
	@( cd Examples; \
	$(MAKE) cleanall; \
	cd ..; \
	cd Lapack_Util; \
	$(MAKE) cleanall; \
	cd .. )

=== scipy/sparse/linalg/_propack/PROPACK/complex8/Makefile ===
#
#     (C) Rasmus Munk Larsen, Stanford University, 2004
#
include ../make.inc
IPATH = -I.

all: lib exampleprogs

### Object files.

DOBJ = clanbpro.o creorth.o cgetu0.o csafescal.o sblasext.o cblasext.o \
      clansvd.o printstat.o cgemm_ovwr.o sgemm_ovwr.o  \
      clansvd_irl.o sbsvd.o critzvec.o c$(MGS).o  second.o 

.f.o:
	$(F77) $(FFLAGS) $(IPATH) -c -o $*.o $*.f
.F.o:
	$(F77) $(FFLAGS) $(IPATH) -c -o $*.o $*.F
.c.o:
	$(CC)  $(CFLAGS) $(IPATH) -c -o $*.o $*.c


lib: liblapack libcpropack_$(PLAT).a 

libcpropack_$(PLAT).a : $(DOBJ)
	rm -f libcpropack_$(PLAT).a
	$(MAKELIB) libcpropack_$(PLAT).a $(DOBJ) 
	$(RANLIB)  libcpropack_$(PLAT).a

liblapack:
	@( cd Lapack_Util; \
	$(MAKE) lib; \
	cd .. )		

exampleprogs: 
	@( cd Examples; \
	$(MAKE) all; \
	cd .. )

test: 
	@( cd Examples; \
	$(MAKE) test; \
	cd .. )

verify: 
	@( cd Examples; \
	$(MAKE) verify; \
	cd .. )

clean:	
	rm -f  *.o *.il lib*_$(PLAT).a
	rm -rf rii_files
	@( cd Examples; \
	$(MAKE) clean; \
	cd ..; \
	cd Lapack_Util; \
	$(MAKE) clean; \
	cd .. )

cleanall:	
	rm -f  *.o  *.a *~ *.il
	rm -rf rii_files
	@( cd Examples; \
	$(MAKE) cleanall; \
	cd ..; \
	cd Lapack_Util; \
	$(MAKE) cleanall; \
	cd .. )

=== debian/changelog ===
scipy (1.16.3-1) unstable; urgency=medium

  * New upstream release
    - applies fix_stats_bivariate_normal_cdf_PR23815.patch
  * hppa: skip all test_accuracy in TestTanhSinh (integrate module)
  * hurd-i386: skip test_tmax (test_mstats_basic.py)

 -- Drew Parsons <dparsons@debian.org>  Fri, 31 Oct 2025 20:06:04 +0100

=== debian/control ===
Source: scipy
Maintainer: Debian Python Team <team+python@tracker.debian.org>
Uploaders: Drew Parsons <dparsons@debian.org>,
           Ondrej Certik <ondrej@certik.cz>,
           David Cournapeau <cournape@gmail.com>,
           Varun Hiremath <varun@debian.org>
Section: python
Priority: optional
Build-Depends: cython3,
               debhelper-compat (= 13),
               dh-sequence-python3,
               pybuild-plugin-pyproject,
               gfortran,
               libblas-dev,
               liblapack-dev,
               libqhull-dev,
               libsuitesparse-dev,
               python3-mesonpy (>= 0.15.0~),
               pkgconf,
               python3-all-dev,
               python3-decorator,
               python3-numpy (>= 1:1.26.0~),
               python3-numpy-dev,
               python3-pooch,
               python3-pybind11 (>= 2.13.2~),
               python3-setuptools,
               python3-wheel,
               python3-pythran (>= 0.15.0~),
               python3-pytest,
               python3-doit (>= 0.36.0~) <!nocheck>,
               python3-hypothesis <!nocheck>,
               python3-yaml
Build-Depends-Indep: dvipng,
                     dh-sequence-sphinxdoc,
                     python3-doc <!nodoc>,
                     python3-docutils,
                     python3-sphinx-copybutton <!nodoc>,
                     python3-jupytext <!nodoc>,
                     python3-matplotlib,
                     python-matplotlib-doc <!nodoc>,
                     python-mpmath-doc <!nodoc>,
                     python3-myst-nb <!nodoc>,
                     python-numpy-doc <!nodoc>,
                     python3-numpydoc <!nodoc>,
                     python3-pydata-sphinx-theme,
                     python3-sphinx,
                     python3-sphinx-design,
                     python3-sphinx-tabs,
                     python-statsmodels-doc <!nodoc>,
                     rdfind,
                     symlinks,
                     texlive-latex-base,
                     texlive-latex-extra
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/python-team/packages/scipy
Vcs-Git: https://salsa.debian.org/python-team/packages/scipy.git
Homepage: https://www.scipy.org/
Rules-Requires-Root: no

Package: python3-scipy
Architecture: any
Multi-Arch: no
Depends: python3-decorator,
         python3-numpy (>= 1:1.26.0~),
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Recommends: g++ | c++-compiler,
            python3-pil,
            python3-pooch,
            python3-yaml
Suggests: python-scipy-doc
Breaks: python3-skbio (<< 0.5.8-3~)
Description: scientific tools for Python 3
 SciPy supplements the popular NumPy module (python-numpy package), gathering a
 variety of high level science and engineering modules together as a single
 package.
 .
 SciPy is a set of Open Source scientific and numeric tools for Python. It
 currently supports special functions, integration, ordinary differential
 equation (ODE) solvers, gradient optimization, genetic algorithms, parallel
 programming tools, an expression-to-C++ compiler for fast execution, and
 others.

Package: python-scipy-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: fonts-open-sans,
         libjs-jquery,
         libjs-mathjax,
         libjs-underscore,
         ${misc:Depends},
         ${sphinxdoc:Depends}
Description: scientific library for Python - documentation
 SciPy supplements the popular NumPy module (python-numpy package), gathering a
 variety of high level science and engineering modules together as a single
 package.
 .
 SciPy is a set of Open Source scientific and numeric tools for Python. It
 currently supports special functions, integration, ordinary differential
 equation (ODE) solvers, gradient optimization, genetic algorithms, parallel
 programming tools, an expression-to-C++ compiler for fast execution, and
 others.
 .
 This package contains documentation for the SciPy library.

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME=scipy

include /usr/share/dpkg/default.mk

unexport LDFLAGS
export FFLAGS="-fPIC"
export ATLAS=None
export PATH := $(CURDIR)/debian/extra_bin:$(PATH)
export SCIPY_USE_PYTHRAN=0

PY3VERS:= $(shell py3versions -v -s)
PY3_DEFAULT:= $(shell py3versions -dv)
TMPDIR := $(CURDIR)/build/tmp
BASE=$(shell pwd)/debian

export SCIPY_USE_PYTHRAN = $(shell if dpkg-query -s python3-pythran >/dev/null 2>/dev/null; then echo 1; else echo 0; fi )

# specify build against generic BLAS/LAPACK. Preferred optimised implementation should be installed
# by the end user, not by the package build.
export PYBUILD_BUILD_ARGS := -Csetup-args=-Dblas=blas -Csetup-args=-Dlapack=lapack -Csetup-args=-Duse-system-libraries=qhull

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  export NPY_NUM_BUILD_JOBS = $(DEB_BUILD_OPTION_PARALLEL)
  export PYBUILD_BUILD_ARGS += -Ccompile-args=-j$(DEB_BUILD_OPTION_PARALLEL)
endif

# identify if any tests are particularly slow
EXTRA_TEST_FLAGS += --durations=20

# some arches time out. Run verbose to see where they got stuck.
VERBOSE_ARCH_LIST := mips64el riscv64 sparc64

# 32-bit stability degraded in scipy 1.12 with more tests
# getting MemoryError, especially in stats tests
# Run verbose to track more closely.
ifneq (,$(findstring $(DEB_HOST_ARCH_BITS), 32))
    VERBOSE_ARCH_LIST += $(DEB_HOST_ARCH)
endif

ifneq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(VERBOSE_ARCH_LIST)$(space)))
    EXTRA_TEST_FLAGS += -v
endif

# stats/tests/test_continuous_basic.py::test_cont_basic[500-200-ncf-arg74] test fails with IntegrationWarning
# https://github.com/scipy/scipy/issues/14519
# test_data (pooch) needs internet or cached data files
SKIP_TEST_LIST += test_cont_basic[500-200-ncf-arg74] test_existence_all test_ascent test_face test_electrocardiogram

# multi-Ellipsis indexing in sparse will be dropped in scipy 1.13
# see https://github.com/scipy/scipy/pull/18541
# it fails tests now so skip and reinstate later for scipy 1.13
SKIP_TEST_LIST += test_multiple_ellipsis_slicing

ifneq (,$(findstring $(DEB_HOST_ARCH), arm64))
    SKIP_TEST_LIST += test_maxiter_worsening[lgmres]
endif

# linalg/tests/test_decomp.py started segfaulting on armel
ifneq (,$(findstring $(DEB_HOST_ARCH), armel))
    SKIP_TEST_LIST += test_decomp test_random_exact test_brunnermunzel_normal_dist test_sparse_dense_divide
    SKIP_TEST_LIST += test_some_code_paths test_gh12218 test_random_state
    SKIP_TEST_LIST += test_against_anderson_gumbel_r test_bootstrap_against_R test_bootstrap_against_itself_1samp
endif

ifneq (,$(findstring $(DEB_HOST_ARCH), armhf))
    SKIP_TEST_LIST += test_gh12218 test_random_state
    SKIP_TEST_LIST += test_against_anderson_gumbel_r test_bootstrap_against_R test_bootstrap_against_itself_1samp
endif

# some tests broken on i386, see https://github.com/scipy/scipy/issues/17839
ifneq (,$(findstring $(DEB_HOST_ARCH), i386))
    SKIP_TEST_LIST += test_find_peaks_exact test_find_peaks_withnoise test_x0_equals_Mb[bicgstab] test_rv_sample
    SKIP_TEST_LIST += test_location_scale[pdf test_examples[True-float64] test_pdf_nolan_samples test_cdf_nolan_samples
    SKIP_TEST_LIST += ellint_rg_xy0_ipp-ellint_rg_xy0 test_hermitian test_random_state
    SKIP_TEST_LIST += test_against_anderson_gumbel_r test_bootstrap_against_R test_bootstrap_against_itself_1samp
    SKIP_TEST_LIST += test_svd_gesdd_nofegfault
endif

ifneq (,$(findstring $(DEB_HOST_ARCH), mips64el))
    # integrate/_ivp/tests/test_ivp.py fail on mips64el
    # see https://github.com/scipy/scipy/issues/16883
    # https://github.com/scipy/scipy/issues/17839#issuecomment-1400636840
    SKIP_TEST_LIST += test_first_step test_classes test_integrality test_integrator test_double_integrator
    SKIP_TEST_LIST += test_nanminmax TestLogM TestExpmFrechet
    SKIP_TEST_LIST += test_2x2_input test_nx2x2_input test_random_matrices_and_powers
    # there are also further complex number problems with numpy 2 on mips64el
    # again see Bug#1094477 and https://github.com/scipy/scipy/issues/21393
    SKIP_TEST_LIST += TestCephes TestEllipCarlson TestErf TestFresnel TestHyper
    SKIP_TEST_LIST += test_boost TestHyp1f1 test_nan_inputs[wofz] test_eval_chebyt_gh20129
    SKIP_TEST_LIST += test_sici_consistency test_shichi_consistency test_wrightomega
    SKIP_TEST_LIST += test_cont_basic test_norm_logcdf test_nan_inputs[airye] test_nan_inputs[sph_harm]
endif

# https://github.com/scipy/scipy/issues/17839#issuecomment-1401780853
ifneq (,$(findstring $(DEB_HOST_ARCH), riscv64))
    SKIP_TEST_LIST += test_maxiter_worsening[lgmres] test_milp_timeout_16545
endif

# test_atol[bicg] only just misses tolerance on s390x, but the design of the test makes it difficult to workaround,
# so skip. See https://github.com/scipy/scipy/issues/17839#issuecomment-1399477182
ifneq (,$(findstring $(DEB_HOST_ARCH), s390x))
    SKIP_TEST_LIST += test_maxiter_worsening test_atol[bicg] test_distance_transform_cdt05
endif

# Bug#1017864 test_kolmogorov.py segfaults on i386 (including hurd)
SKIP_KOLMOGOROV_ARCH_LIST := i386 hurd-i386
ifneq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(SKIP_KOLMOGOROV_ARCH_LIST)$(space)))
    SKIP_TEST_LIST += TestSmirnovp
endif

# some tests in linalg test_matfuncs.py fail on several arches
# in particular riscv64 hppa sparc64 share many common test failure
SKIP_TestLogM_ARCH_LIST := riscv64 hppa sparc64
ifneq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(SKIP_TestLogM_ARCH_LIST)$(space)))
    SKIP_TEST_LIST += TestLogM TestExp test_expm
    SKIP_TEST_LIST += test_random_matrices_and_powers test_2x2_input test_nx2x2_input
    SKIP_TEST_LIST += test_zoh test_foh test_transferfunction
    SKIP_TEST_LIST += test_zerospolesgain test_discrete_approx test_simo_tf test_multioutput
    SKIP_TEST_LIST += test_simo_tf test_multioutput TestC2dLti TestC2dInvariants
    SKIP_TEST_LIST += test_second_order test_integrator test_double_integrator
    SKIP_TEST_LIST += test_jordan_block test_array_like TestStep test_operators
    SKIP_TEST_LIST += test_nan_inputs[airye] test_nan_inputs[sph_harm]
endif

# some archs fail test_cython (special test_extending) with numpy 1.26
# but will pass with numpy 2 due to complex type changes
# see https://github.com/scipy/scipy/issues/21393
SKIP_NEEDS_NUMPY2_ARCH_LIST := mips64el alpha hppa powerpc ppc64
ifneq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(SKIP_NEEDS_NUMPY2_ARCH_LIST)$(space)))
    SKIP_TEST_LIST += test_cython
endif

ifneq (,$(findstring $(DEB_HOST_ARCH), alpha))
    SKIP_TEST_LIST += test_read_over64bit_integer_dense test_read_over64bit_integer_sparse
    SKIP_TEST_LIST += test_hyp0f1 test_eval_chebyt_gh20129 test_rvs_gh18372
endif

# hppa runs out of memory in test_bootstrap_against_theory
ifneq (,$(findstring $(DEB_HOST_ARCH), hppa))
    SKIP_TEST_LIST += test_nodata test_cont_basic[500-200-semicircular-arg89] test_bootstrap_against_theory test_distance_transform_cdt05
    SKIP_TEST_LIST += test_onenormest_linear_operator test_against_anderson_gumbel_r test_gh12218
    SKIP_TEST_LIST += test_roots_hermite_asy test_bootstrap_against_R bootstrap_against_itself test_against_f_oneway
    SKIP_TEST_LIST += test_QRVS_shape_consistency[1-d_out1-1-size_out1-qrng1-NumericalInversePolynomial] \
	test_QRVS_shape_consistency[None-d_out0-size_in4-size_out4-None-NumericalInversePolynomial] \
	test_QRVS_shape_consistency[None-d_out0-size_in4-size_out4-qrng1-NumericalInversePolynomial] \
	test_QRVS_shape_consistency[None-d_out0-size_in4-size_out4-qrng2-NumericalInversePolynomial] \
	test_QRVS_shape_consistency[1-d_out1-size_in3-size_out3-None-NumericalInversePolynomial] \
	test_QRVS_shape_consistency[1-d_out1-size_in4-size_out4-None-NumericalInversePolynomial] \
	test_QRVS_shape_consistency[1-d_out1-size_in4-size_out4-qrng1-NumericalInversePolynomial] \
	test_QRVS_shape_consistency[1-d_out1-size_in4-size_out4-qrng2-NumericalInversePolynomial] \

=== debian/tests/control ===
Tests: python3
Depends: build-essential, python3-scipy, python3-pytest, python3-all, python3-all-dev,
 python3-doit, python3-pil, python3-pooch, python3-hypothesis, python3-yaml

Tests: python3-network
Depends: build-essential, python3-scipy, python3-pytest, python3-all, python3-all-dev,
 python3-doit, python3-pil, python3-pooch, python3-hypothesis, python3-yaml
Restrictions: needs-internet

# short test on all python versions including debug
Tests: python3-smoke
Depends: python3-scipy, python3-pytest, python3-all, python3-doit, python3-hypothesis, python3-yaml

#needs root for update-alternatives, build-essential for libc6-dev (ctype libm.so)
Tests: openblas
Restrictions: needs-root
Depends: build-essential, python3-scipy, python3-pytest, python3, python3-doit,
 python3-hypothesis, python3-yaml, libopenblas-dev
Architecture: amd64 arm64 armhf i386 powerpc ppc64el ppc64 kfreebsd-i386 kfreebsd-amd64 mips64el riscv64 sparc64 s390x

#needs root for update-alternatives, build-essential for libc6-dev (ctype libm.so)
Tests: blis
Restrictions: needs-root
Depends: build-essential, python3-scipy, python3-pytest, python3, python3-doit,
 python3-hypothesis, python3-yaml, libblis-dev
